#!/usr/bin/perl

# Utility code to animate screenshots.
# This code/feature is *not* necessary for gameplay, and is provided as-is.

use strict;

my @ppms = sort glob("*.ppm");

(-e "screenshot000.ppm" || -e "screenshot000.gif") or die "screenshot000.ppm (or screenshot000.gif) MUST exist in order for this to work.";

print "## Converting PPM -> GIF\n";
map {
    my ($prefix) = $_ =~ /^(.+?)\.ppm$/i
        or die "Could not match ppm filename in '$_'";
    system("ppmquant 256 $prefix.ppm | ppmtogif >$prefix.gif")
        and die "Could not ppmquant | ppmtogif the file '$prefix.ppm'";
    unlink "$prefix.ppm";
} @ppms;

print "## Joining GIFs into an animated GIF\n";
system("intergif -join -loop -i -d 12 -best 32 -trim -o screenshot.gif screenshot000.gif")    
    and die "Could not intergif the files to form 'screenshot.gif'";

print "## Cleaning up old GIFs\n";
map { unlink $_; } glob("*[0-9][0-9][0-9].gif");
